# 
# Copyright (C) 1996-2001 LAAS/CNRS 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
#    - Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    - Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 
# $LAAS: zingaro.tcl,v 1.1 2006/02/02 16:05:48 matthieu Exp $
#

array set station_vertices \
    { \
	  0 { 0.45 0.55 } \
	  1 { 0.45 -0.20 } \
      }

array set station_boundaries \
    { \
	  0 { 2 0 1 } \
	  1 { 2 0 1 } \
	  2 { 2 0 1 } \
	  3 { 2 0 1 } \
	  4 { 2 0 1 } \
	  5 { 2 0 1 } \
	  6 { 2 0 1 } \
      }

array set cell_vertices  \
    { \
	  0 { 0.40 -6.26 } \
	  1 { 11.90 -6.26 } \
	  2 { 11.90 0.60 } \
	  3 { 0.40 0.60 } \
	  4 { 13.00 -6.26 } \
	  5 { 13.00 0.69 } \
      }

array set cell_boundaries \
    { \
	  0 { 4 0 1 2 3 } \
	  1 { 4 1 4 5 2 } \
      }

array set obstacle_vertices \
    { \
	  0 { 0.35 -6.27 } \
	  1 { 0.35 0.60 } \
	  2 { 1.93 -5.87 } \
	  3 { 1.93 -6.27 } \
	  4 { 6.47 -0.88 } \
	  5 { 6.47 0.60 } \
	  6 { 7.95 -8.90 } \
	  7 { 7.21 -0.88 } \
	  8 { 7.95 -6.70 } \
	  9 { 0.35 -4.37 } \
	  10 { 1.09 -4.37 } \
	  11 { 1.09 -5.87 } \
	  12 { 1.61 -0.20 } \
	  13 { 1.61 0.20 } \
	  14 { 0.35 -0.20 } \
	  15 { 11.90 0.60 } \
	  16 { 11.90 -0.20 } \
	  17 { 7.25 -0.20 } \
	  18 { 11.30 -0.20 } \
	  19 { 11.90 -0.20 } \
	  20 { 11.90 -4.90 } \
	  21 { 11.30 -4.90 } \
	  22 { 5.54 -6.70 } \
	  23 { 5.54 -6.27 } \
	  24 { 8.39 -6.27 } \
	  25 { 8.39 -8.90 } \
	  26 { 7.25 0.60 } \
	  27 { 7.20 0.60 } \
	  28 { 3.40 0.20 } \
	  29 { 3.40 0.60 } \
      }
array set obstacle_boundaries \
    { \
	  0 { 6 0 9 10 11 2 3 } \
	  1 { 4 4 5 27 7 } \
	  2 { 6 22 23 24 25 6 8 } \
	  3 { 6 1 29 28 13 12 14 } \
	  4 { 4 18 19 20 21 } \
	  5 { 4 15 16 17 26 } \
      }

# dimensions
set xmin -5
set xmax 10
set ymin -15
set ymax 0
set zmin 0
set zmax 2.0
 
# point de vue initial
set obsDist 10
set obsAzi 0
set obsElev 30
set obsX 6
set obsY -4
set obsZ 0.8
 
 
# signale qu'un modele d'environnement est defini
set envDefined True





