# 
# Copyright (C) 1996-2001 LAAS/CNRS 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
#    - Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    - Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 
# $LAAS: h2bis.tcl,v 1.9 2003/02/09 16:31:29 matthieu Exp $
#----------------------------------------------------------------------
package provide Gdhe::models 1.0
### 
### Hilare2 bis
###

proc h2bis {{l "unload"}} {

    object h2bis {
	cullFace True
	concave False
	color 200 200 200
	# prisme de base - partie inferieure
	prism 8 0.0 0.0 0.2 \
	    -.60 -.29 .26 \
	    -.60 .29 .26 \
	    -.54 .351 .26 \
	    .54 .351 .26 \
	    .60 .29 .26 \
	    .60 -.29 .26 \
	    .54 -.351 .26 \
	    -.54 -.351 .26 
	# prisme de base - partie superieure 
	prism 6 0.0 0.0 0.33 \
	    -.60 -.29 .45 \
	    -.60 .29 .45 \
	    -.54 .351 .45 \
	    .31 .351 .45 \
	    .31 -.351 .45 \
	    -.54 -.351 .45

	# Supports du bras
	color 50 50 50
	box .42 .0 .78 .27 .23 .02
	color 200 200 200
	box .45 .0 .80 .20 .21 .015
	box 0.41 0 .755 0.025 0.7 0.025
	box 0.41 0.33 0.46 0.025 0.025 0.295
	box 0.41 -0.33 0.46 0.025 0.025 0.295
	box 0.36 0.33 0.73 0.1 0.025 0.025
	box 0.36 -0.33 0.73 0.1 0.025 0.025
	color 0 0 0
	box 0.41 0.3525 .755 0.025 0.005 0.025
	box 0.41 -0.3525 .755 0.025 0.005 0.025
	

	color 30 30 30 	
	# sick
	color 20 20 200
	box .375 .0 .55 .15 .15 .07
	box .325 .0 .47 .05 .15 .08
	box .375 .0 .45 .15 .15 .02
	color 20 20 20
	box .39 .0 .47 .08 .10 .08

	# plateau superieur
	color 50 50 50 
	box -.12 0.0 .77 .45 .51 .150
	color 30 30 30 
	# bordure superieur du corps 
	# prism 6 0.0 0.0 0.005 \
	    -.601 -.29 .774 \
	    -.601 .29 .774 \
	    -.54 .352 .774 \
	    .25 .352 .774  \
	    .25 -.352 .774 \
	    -.54 -.352 .774
	# bumper
	prism 8 0.0 0.0 0.04 \
	    -.655 -.29 .25 \
	    -.655 .29 .25 \
	    -.54 .405 .25 \
	    .54 .405 .25 \
	    .655 .29 .25 \
	    .655 -.29 .25 \
	    .54 -.405 .25 \
	    -.54 -.405 .25
	# us 
	box .365 .352 .31 .04 .02 .12
	box .499 .352 .31 .04 .02 .12
	box .602 .15 .31 .02 .04 .12
	box .602 .052 .31 .02 .04 .12
	box .602 -.052 .31 .02 .04 .12 
	box .602 -.15 .31 .02 .04 .12
	box .499 -.352 .31 .04 .02 .12
	box .365 -.352 .31 .04 .02 .12
	box .22 -.358 .365 .04 .02 .12
	box .075 -.358 .365 .04 .02 .12
	box -.045 -.358 .365 .04 .02 .12
	box -.195 -.358 .365 .04 .02 .12
	box  -.365 -.352 .31 .04 .02 .12
	box -.499 -.352 .31 .04 .02 .12
	box -.602 -.150 .31 .02 .04 .12
	box -.602 -.052 .31 .02 .04 .12
	box -.602 .052 .31 .02 .04 .12
	box -.602 .150 .31 .02 .04 .12
	box -.499 .352 .31 .04 .02 .12
	box -.365 .352 .31 .04 .02 .12
	box -.195 .358 .365 .04 .02 .12
	box -.045 .358 .365 .04 .02 .12
	box .075 .358 .365 .04 .02 .12
	box .22 .358 .365 .04 .02 .12
	
	color 0 80 50 
	# roues motrices 
	cylinder 0.0 0.28 0.15 y 0.30 0.07
	cylinder 0.0 -0.35 0.15 y 0.30 0.07
	# roues folles
	cylinder .58 .25 .075 y .15 .1
	cylinder .58 -.35 .075 y .15 .1
	cylinder -.42 .25 .075 y .15 .1
	cylinder -.42 -.35 .075 y .15 .1
	
	color 150 150 150
	# flasques des roues 
	cylinder 0.0 0.35 0.15 y 0.25 0.001
	cylinder 0.0 -0.351 0.15 y 0.25 0.001
	cylinder .58 .249 .075 y .125 .102
	cylinder .58 -.351 .075 y .125 .102
	cylinder -.42 .249 .075 y .125 .102
	cylinder -.42 -.351 .075 y .125 .102
	box 0.05 0.0 0.05 0.25 0.50 0.3

	color 200 100 0
	# supports des roues folles
	cylinder .5 .3 .225 z .09 .025
	cylinder .5 -.3 .225 z .09 .025
	cylinder  -.5 .3 .225 z .09 .025
	cylinder -.5 -.3 .225 z .09 .025
	prism 5 0.0 0.03 0.0 \
	    .455 .285 .225 \
	    .455 .285 .045 \
	    .575 .285 .0 \
	    .655 .285 .025 \
	    .545 .285 .225
	prism 5 0.0 0.03 0.0 \
	    .455 -.315 .225 \
	    .455 -.315 .045 \
	    .575 -.315 .0 \
	    .655 -.315 .025 \
	    .545 -.315 .225
	prism 5 0.0 0.03 0.0 \
	    -.545 .285 .225 \
	    -.545 .285 .045 \
	    -.425 .285 .0 \
	    -.345 .285 .025 \
	    -.455 .285 .225 
	prism 5 0.0 0.03 0.0 \
	    -.545 -.315 .225 \
	    -.545 -.315 .045 \
	    -.425 -.315 .0 \
	    -.345 -.315 .025 \
	    -.455 -.315 .225
	color 80 80 80
	# axe des roues motrices
	cylinder 0.0 -0.352 0.15 y 0.08 0.704
	
    }
    if {![string compare $l load ]} {
	# Dessin le container dans le robot
	object container_h2bis {
	    color 180 13 50
	    # :cube container
	    box -.15 0.0 .92	.4 .5 .12
	}
    }
}


proc h2bis_drapeau_pmo { color_r color_g color_b } {
    global faces_RS diametre_Drapeau

    pushMatrix
    color $color_r $color_g $color_b
 #   object h2_objet_drapeau {
	cullFace True

	#:cylinder de base

	cylinder -.48 0.0 0.78  z .1 0.2

	#:sphere du drapeau

	sphere -.48 0.0 1.00 $diametre_Drapeau $faces_RS
  #  }
    popMatrix
}

