# 
# Copyright (C) 1996-2005 LAAS/CNRS 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
#    - Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    - Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 
# Florent Lamiraux
#
# $LAAS: laserEcho.tcl,v 1.7 2005/08/12 13:37:06 olefebvr Exp $
#
#package provide Gdhe::models 1.0

##
## Draw laser sensor data
##
proc laserEcho {} {

    object LaserEcho {
	cullFace True
	concave False
	color 255 000 000
	box 0  0  -0.05  0.1 0.1 0.1
    }
}

proc laserEchoPriority1 {} {

     object LaserEcho1 {
 	cullFace True
 	concave False
 	color 255 000 000
 	box 0  0  -0.05  0.1 0.1 0.1
     }
}

# a green echo
proc laserEchoPriority0 {} {

     object LaserEcho0 {
 	cullFace True
 	concave False
 	color 000 255 000
 	box 0  0  -0.05  0.1 0.1 0.1
     }
}

# a blue echo
proc laserEchoPriority2 {} {

     object LaserEcho0 {
 	cullFace True
 	concave False
 	color 000  000 255
 	box 0  0  -0.05  0.1 0.1 0.1
     }
}

proc laserSeg { x1 y1 x2 y2 } {
    color 000 255 000
    polyline 2 $x1 $y1 0.0 $x2 $y2 0.0
}

proc laserSegCyl { l } {
    color 255 000 000
    cylinder 0.0 0.0 0.0 x 0.1 0.1 $l 4
}

proc laserSegCylColor { l r g b } {
    color $r $g $b
    cylinder 0.0 0.0 0.0 x 0.1 0.1 $l 4
}

