# 
# Copyright (C) 2005-2006 LAAS/CNRS 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
#    - Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    - Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 
# $LAAS: neobotix.tcl,v 1.5 2007/02/07 15:51:05 matthieu Exp $
#----------------------------------------------------------------------
package provide Gdhe::models 1.0

proc neo {{azi 0} {site -20}} {
    object Neo {
	cullFace True 
	# Corps 
	color 180 180 180 
	box 0 0 0.20 .671 .666 0.01 
	box 0 0 0.21 .510 .666 0.2
	box 0 0 0.21 .608 .526 0.4
    
	# CPU2 
	color 90 90 80
	box -0.13 0 .60 .32 .5 .18

	# roues
	color 120 110 60
	cylinder +0.0 -0.300 0.093 y 0.185 0.05
	cylinder +0.0  0.275 0.093  y 0.185 0.05
	color 120 120 120 
	box 0.10 0 0.08 0.10 0.52 0.12
	box -0.10 0 0.12 0.08 0.52 0.08
	color 120 50 40 
	# cylinder 0.200 -0.225 0.075 y 0.15 0.05
	cylinder -0.250 -0.002 0.08 y 0.16 0.05
	cylinder 0.250 -0.225 0.08 y 0.16 0.05
	cylinder 0.250 +0.220 0.08 y 0.16 0.05
	# sick
	color 20 20 200
	box .375 .0 .30 .15 .15 .07
	box .325 .0 .22 .05 .15 .08
	box .375 .0 .20 .15 .15 .02
	color 20 20 20
	box .39 .0 .22 .08 .10 .08
	# sick
	color 20 20 200
	box -.375 .0 .30 .15 .15 .07
	box -.325 .0 .22 .05 .15 .08
	box -.375 .0 .20 .15 .15 .02
	color 20 20 20
	box -.39 .0 .22 .08 .10 .08
	
    }
    # pushMatrix
    # translate 0.20 0 0.60
    # pa10 0 -30 30 0 -30 0
    # popMatrix
    # Ecran tactile 
    pushMatrix
    translate -.30 0 0.80
    rotate 15 0 1 0
    color 60 60 60 
    box 0 0 0 .075 .4 .33
    popMatrix
    # Platine 
    # Mat
    pushMatrix
    translate -0.15 0 0.79
    color 150 150 150
    box 0 0 0 0.1 0.5 0.01
    cylinder 0 0 0 z .05 0.8
    translate 0 0 0.8
    jidoPlatine $azi $site
    popMatrix
}


#----------------------------------------------------------------------
### 
### platine
###
proc jidoPlatine {azi site} {
    pushMatrix
    object platineInf {
        color 30 30 30
        box -0.02 0.0 0 0.08 0.05 0.05
        color 180 180 180
        cylinder -0.075 0 0.025 x 0.012 0.02
    }
    rotate $azi 0 0 1
    object platineMid {
        color 30 30 30
        box -0.02 0 0.051 0.08 0.05 0.05
        color 180 180 180
        cylinder -0.075 0 0.075 x 0.012 0.02
        translate 0 0 0.075
    }
    rotate $site 0 -1 0
    object platineSup {
        color 30 30 30
        box 0 -0.028 -0.01 0.02 0.005 0.05
        box 0  0.028 -0.01 0.02 0.005 0.05
        color 100 100 100
        box 0 0 0.04 0.02 0.3 0.005
        color 20 20 20
        box -0.013 0.14 0.045 0.053 0.045 0.035
        color 70 70 70
        cylinder 0.01 0.14 0.065 x 0.028 0.01
        cylinder 0.02 0.14 0.065 x 0.028 0.05 0.02
        cylinder 0.04 0.14 0.065 x 0.05 0.008
        color 20 20 20
        box -0.013 -0.14 0.045 0.053 0.045 0.035
        color 70 70 70
        cylinder 0.01 -0.14 0.065 x 0.028 0.01
        cylinder 0.02 -0.14 0.065 x 0.028 0.05 0.02
        cylinder 0.04 -0.14 0.065 x 0.05 0.008
	color 30 30 160
	box 0.03 0 0.045 0.04 0.05 0.065
	color 10 10 10 
	cylinder 0.05 0 0.0725 x 0.01 0.015
    }
    popMatrix
}
